/****************************************************************************
    BSch3V schematic capture
    Copyright (C) 1997-2005 H.Okada

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*****************************************************************************/

//CE3t@C̏

//J}܂͉s؂
//Rg[ƃXy[XAJ}A%  %xx(xx̓AXL[R[h)ɒuB


#ifndef CE3IO_H
#define CE3IO_H

#include <stdio.h>
#include <string>
using namespace std;

class SReadCE3{
protected:
	LPCTSTR	m_buff;
	LPCTSTR	m_pread;
	//CFile*	m_pCfile;
	FILE*	m_pfile;
	int		m_lineCount;	 
	int  getC();
	bool isSpace(TCHAR cc);
	bool isDelim(TCHAR cc);
public:
	SReadCE3();		//RXgN^
	~SReadCE3();	//fXgN^
	//bool Attach(CFile* pCfile);
	bool Attach(FILE* pFile);
	bool Attach(LPCTSTR buff);
	int ReadRecord(wstring& s);
	int ReadRecord(LPTSTR pBuff,int nBuffLen);
	int Line(){return m_lineCount;}
	int SkipTo(LPTSTR pszSkipTo);
	int SkipTo(const wstring& strSkipTo);
};

class SWriteCE3{
protected:
	//CFile*	m_pCfile;
	FILE*	m_pfile;
	wstring*	m_pstr;
	bool	m_bNewLine; 
	int  putC(wint_t c);

public:
	SWriteCE3();	//RXgN^
	~SWriteCE3();	//fXgN^
	//bool Attach(CFile* pCfile);
	bool Attach(FILE* pFile);
	bool Attach(wstring* pstr);
	int WriteRecord(LPCTSTR pBuff);
	int WriteRecord(const wstring& s);
	int WriteRecordInt(const wstring& var,int val);
	int WriteRecordString(const wstring& var,const wstring& val);
	int WriteEOL();
};

#endif